Index: branches/histogram/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame	(revision 6195)
@@ -28,14 +28,14 @@
   [Plugin("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding","Provides operators and related classes for the symbolic expression tree encoding.", "3.4.0.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Analysis", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Collections", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Common", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Core", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Data", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Operators", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3.3.0")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3.3.0")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin : PluginBase {
   }
Index: branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLabMainFormWindowsFormsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLabMainFormWindowsFormsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/HeuristicLabMainFormWindowsFormsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.MainForm.WindowsForms {
-  [Plugin("HeuristicLab.MainForm.WindowsForms", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.MainForm.WindowsForms", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.MainForm.WindowsForms-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.MainForm.WindowsForms/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.MainForm {
-  [Plugin("HeuristicLab.MainForm", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.MainForm", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.MainForm-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/histogram/HeuristicLab.MainForm/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.MainForm/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.MainForm/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
 
 namespace HeuristicLab.Operators.Programmable {
-  [Plugin("HeuristicLab.Operators.Programmable", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Operators.Programmable", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Operators.Programmable-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.CodeEditor", "3.3")]
Index: branches/histogram/HeuristicLab.Operators.Programmable/3.3/ProgrammableSingleSuccessorOperator.cs
===================================================================
--- branches/histogram/HeuristicLab.Operators.Programmable/3.3/ProgrammableSingleSuccessorOperator.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Programmable/3.3/ProgrammableSingleSuccessorOperator.cs	(revision 6195)
@@ -1,7 +1,28 @@
-﻿
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
 namespace HeuristicLab.Operators.Programmable {
 
Index: branches/histogram/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/Plugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Views.GraphVisualization.Views/3.3/Plugin.cs.frame	(revision 6195)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization.Views {
-  [Plugin("HeuristicLab.Operators.Views.GraphVisualization.Views-3.3", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Operators.Views.GraphVisualization.Views-3.3", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Operators.Views.GraphVisualization.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/HeuristicLabOperatorsViewsGraphVisualizationPlugin.cs.frame	(revision 6195)
@@ -29,5 +29,5 @@
   /// Plugin class for HeuristicLab.Operators.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Operators.Views.GraphVisualization", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Operators.Views.GraphVisualization", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Operators.Views.GraphVisualization-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Views.GraphVisualization/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Views/3.3/HeuristicLabOperatorsViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Operators.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Operators.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Operators.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Operators.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/histogram/HeuristicLab.Operators.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Operators plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Operators", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Operators", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Operators-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- branches/histogram/HeuristicLab.Operators/3.3/Operator.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators/3.3/Operator.cs	(revision 6195)
@@ -33,5 +33,5 @@
   [Item("Operator", "Base class for operators.")]
   [StorableClass]
-  public abstract class Operator : ParameterizedNamedItem, IOperator {
+  public abstract class Operator : ParameterizedNamedItem, IOperator, IStatefulItem {
     public override Image ItemImage {
       get {
@@ -107,4 +107,9 @@
     }
 
+    public virtual void InitializeState() { }
+    public virtual void ClearState() {
+      executionContexts = new Lazy<ThreadLocal<IExecutionContext>>(() => { return new ThreadLocal<IExecutionContext>(); }, LazyThreadSafetyMode.ExecutionAndPublication);
+    }
+
     public virtual IOperation Execute(IExecutionContext context, CancellationToken cancellationToken) {
       try {
@@ -116,5 +121,6 @@
         OnExecuted();
         return next;
-      } finally {
+      }
+      finally {
         foreach (IParameter param in Parameters)
           param.ExecutionContext = null;
Index: branches/histogram/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLabOptimizationOperatorsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLabOptimizationOperatorsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization.Operators/3.3/HeuristicLabOptimizationOperatorsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Optimization.Operators plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Optimization.Operators", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Optimization.Operators", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Optimization.Operators-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Optimization.Operators/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization.Operators/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization.Operators/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Optimization.Views/3.3/HeuristicLabOptimizationViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization.Views/3.3/HeuristicLabOptimizationViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization.Views/3.3/HeuristicLabOptimizationViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Optimization.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Optimization.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Optimization.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Optimization.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Optimization.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs
===================================================================
--- branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 6195)
@@ -227,4 +227,8 @@
       series.Points.Clear();
       runToDataPointMapping.Clear();
+
+      chart.ChartAreas[0].AxisX.IsMarginVisible = xAxisValue != AxisDimension.Index.ToString();
+      chart.ChartAreas[0].AxisY.IsMarginVisible = yAxisValue != AxisDimension.Index.ToString();
+
       if (Content != null) {
         foreach (IRun run in this.Content)
@@ -433,5 +437,5 @@
     #region Drag & drop and tooltip
     private void chart_MouseDoubleClick(object sender, MouseEventArgs e) {
-      HitTestResult h = this.chart.HitTest(e.X, e.Y);
+      HitTestResult h = this.chart.HitTest(e.X, e.Y, ChartElementType.DataPoint);
       if (h.ChartElementType == ChartElementType.DataPoint) {
         IRun run = (IRun)((DataPoint)h.Object).Tag;
@@ -445,4 +449,5 @@
         this.chart.ChartAreas[0].CursorY.SelectionStart = this.chart.ChartAreas[0].CursorY.SelectionEnd;
       }
+      UpdateAxisLabels();
     }
 
@@ -557,10 +562,7 @@
       colorXAxisButton.Enabled = colorYAxisButton.Enabled = axisSelected;
 
-      if (!xAxisComboBox.DroppedDown)
-        xAxisValue = (string)xAxisComboBox.SelectedItem;
-      if (!yAxisComboBox.DroppedDown)
-        yAxisValue = (string)yAxisComboBox.SelectedItem;
-      if (!sizeComboBox.DroppedDown)
-        sizeAxisValue = (string)sizeComboBox.SelectedItem;
+      xAxisValue = (string)xAxisComboBox.SelectedItem;
+      yAxisValue = (string)yAxisComboBox.SelectedItem;
+      sizeAxisValue = (string)sizeComboBox.SelectedItem;
 
       UpdateDataPoints();
@@ -602,5 +604,5 @@
         for (double i = axis.Minimum; i <= axis.Maximum; i += axis.LabelStyle.Interval) {
           TimeSpan time = TimeSpan.FromSeconds(i);
-          string x = string.Format("{0:00}:{1:00}:{2:00}", (int)time.Hours, time.Minutes, time.Seconds);
+          string x = string.Format("{0:00}:{1:00}:{2:00}", time.Hours, time.Minutes, time.Seconds);
           axis.CustomLabels.Add(i - axis.LabelStyle.Interval / 2, i + axis.LabelStyle.Interval / 2, x);
         }
Index: branches/histogram/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs
===================================================================
--- branches/histogram/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs	(revision 6195)
@@ -260,6 +260,9 @@
     public event EventHandler Prepared;
     protected virtual void OnPrepared() {
+      ExecutionState = ExecutionState.Prepared;
       ExecutionTime = TimeSpan.Zero;
-      ExecutionState = ExecutionState.Prepared;
+      foreach (IStatefulItem statefulObject in this.GetObjectGraphObjects().OfType<IStatefulItem>()) {
+        statefulObject.InitializeState();
+      }
       EventHandler handler = Prepared;
       if (handler != null) handler(this, EventArgs.Empty);
@@ -280,4 +283,7 @@
     protected virtual void OnStopped() {
       ExecutionState = ExecutionState.Stopped;
+      foreach (IStatefulItem statefulObject in this.GetObjectGraphObjects().OfType<IStatefulItem>()) {
+        statefulObject.ClearState();
+      }
       runsCounter++;
       runs.Add(new Run(string.Format("{0} Run {1}", Name, runsCounter), this));
Index: branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLabOptimizationPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLabOptimizationPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization/3.3/HeuristicLabOptimizationPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Optimization plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Optimization", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Optimization", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Optimization-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Optimization/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimization/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimization/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 6195)
@@ -116,4 +116,5 @@
     <EmbeddedResource Include="Documents\SGP_SymbReg.hl" />
     <EmbeddedResource Include="Documents\VNS_TSP.hl" />
+    <EmbeddedResource Include="Documents\PSO_Schwefel.hl" />
     <None Include="HeuristicLabOptimizerPlugin.cs.frame" />
     <Compile Include="CreateExperimentDialog.cs">
Index: branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 6195)
@@ -24,5 +24,5 @@
 
 namespace HeuristicLab.Optimizer {
-  [Plugin("HeuristicLab.Optimizer", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Optimizer", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Optimizer-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
@@ -39,5 +39,5 @@
   }
 
-  [Application("Optimizer", "HeuristicLab Optimizer 3.3.3.$WCREV$")]
+  [Application("Optimizer", "HeuristicLab Optimizer 3.3.4.$WCREV$")]
   internal class HeuristicLabOptimizerApplication : ApplicationBase {
     public override void Run() {
Index: branches/histogram/HeuristicLab.Optimizer/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Optimizer/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Optimizer/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.ParallelEngine/3.3/HeuristicLabParallelEnginePlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.ParallelEngine/3.3/HeuristicLabParallelEnginePlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.ParallelEngine/3.3/HeuristicLabParallelEnginePlugin.cs.frame	(revision 6195)
@@ -29,5 +29,5 @@
   /// Plugin class for HeuristicLab.ParallelEngine plugin.
   /// </summary>
-  [Plugin("HeuristicLab.ParallelEngine", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.ParallelEngine", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.ParallelEngine-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: branches/histogram/HeuristicLab.ParallelEngine/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.ParallelEngine/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.ParallelEngine/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Parameters.Views/3.3/HeuristicLabParametersViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Parameters.Views/3.3/HeuristicLabParametersViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Parameters.Views/3.3/HeuristicLabParametersViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Parameters.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Parameters.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Parameters.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Parameters.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Parameters.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Parameters.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Parameters.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Parameters/3.3/HeuristicLabParametersPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Parameters/3.3/HeuristicLabParametersPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Parameters/3.3/HeuristicLabParametersPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Parameters plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Parameters", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Parameters", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Parameters-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Parameters/3.3/Parameter.cs
===================================================================
--- branches/histogram/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Parameters/3.3/Parameter.cs	(revision 6195)
@@ -33,5 +33,5 @@
   [Item("Parameter", "A base class for parameters.")]
   [StorableClass]
-  public abstract class Parameter : NamedItem, IParameter {
+  public abstract class Parameter : NamedItem, IParameter, IStatefulItem {
     public override Image ItemImage {
       get {
@@ -126,4 +126,10 @@
     }
 
+    public virtual void InitializeState() { }
+    public virtual void ClearState() {
+      cachedActualValues = new Lazy<ThreadLocal<IItem>>(() => { return new ThreadLocal<IItem>(); }, LazyThreadSafetyMode.ExecutionAndPublication);
+      executionContexts = new Lazy<ThreadLocal<IExecutionContext>>(() => { return new ThreadLocal<IExecutionContext>(); }, LazyThreadSafetyMode.ExecutionAndPublication);
+    }
+
     public override string ToString() {
       return Name;
Index: branches/histogram/HeuristicLab.Parameters/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Parameters/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Parameters/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Persistence.GUI/3.3/HeuristicLabPersistenceGUIPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Persistence.GUI/3.3/HeuristicLabPersistenceGUIPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Persistence.GUI/3.3/HeuristicLabPersistenceGUIPlugin.cs.frame	(revision 6195)
@@ -4,5 +4,5 @@
 namespace HeuristicLab.Persistence.GUI {
 
-  [Plugin("HeuristicLab.Persistence.GUI", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Persistence.GUI", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Persistence.GUI-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
Index: branches/histogram/HeuristicLab.Persistence.GUI/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Persistence.GUI/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Persistence.GUI/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -52,3 +52,3 @@
 //
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj
===================================================================
--- branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj	(revision 6194)
+++ branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLab.Persistence-3.3.csproj	(revision 6195)
@@ -110,8 +110,4 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\HeuristicLab.PluginInfrastructure\3.3\ICSharpCode.SharpZipLib.dll</HintPath>
-    </Reference>
-    <Reference Include="log4net, Version=1.2.10.0, Culture=neutral, PublicKeyToken=1b44e1d426115821, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\HeuristicLab.ExtLibs\HeuristicLab.log4net\1.2.10.0\log4net.dll</HintPath>
     </Reference>
     <Reference Include="System" />
Index: branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLabPersistencePlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLabPersistencePlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Persistence/3.3/HeuristicLabPersistencePlugin.cs.frame	(revision 6195)
@@ -27,5 +27,5 @@
   /// The plugin for HeuriticLab.Persistence
   /// </summary>
-  [Plugin("HeuristicLab.Persistence", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Persistence", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Persistence-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Tracing", "3.3")]
Index: branches/histogram/HeuristicLab.Persistence/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Persistence/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Persistence/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -52,3 +52,3 @@
 //
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
